import GameController

class InputController {
  static let shared = InputController()
    
    struct Point {
      var x: Float
      var y: Float
      static let zero = Point(x: 0, y: 0)
    }

    
    var keysPressed: Set<GCKeyCode> = []
    
    var leftMouseDown = false
    var mouseDelta = Point.zero
    var mouseScroll = Point.zero

    
    private init() {
        print("in init")
      let center = NotificationCenter.default
      center.addObserver(
        forName: .GCKeyboardDidConnect,
        object: nil,
        queue: nil) { notification in
            print("in observer %s", notification.object)
          let keyboard = notification.object as? GCKeyboard
            if keyboard == nil {
                print("keyb is nil")
            }
            print("after let keyb")
            
            if (keyboard?.keyboardInput == nil) {
                print("keyb input is nil")
            }
            
            
            
            keyboard?.keyboardInput?.keyChangedHandler
              = { _, _, keyCode, pressed in
                  
            if pressed {
                
              self.keysPressed.insert(keyCode)
            } else {
              self.keysPressed.remove(keyCode)
            }
          }
            
            
      }
        
        
        center.addObserver(
          forName: .GCMouseDidConnect,
          object: nil,
          queue: nil) { notification in
            let mouse = notification.object as? GCMouse
              
              // 1
              mouse?.mouseInput?.leftButton.pressedChangedHandler = { _, _, pressed in
                self.leftMouseDown = pressed
                  
              }
              // 2
              mouse?.mouseInput?.mouseMovedHandler = { _, deltaX, deltaY in
                self.mouseDelta = Point(x: deltaX, y: deltaY)
                  
              }
              // 3
              mouse?.mouseInput?.scroll.valueChangedHandler = { _, xValue, yValue in
                self.mouseScroll.x = xValue
                self.mouseScroll.y = yValue
                  
              }

        }
        
#if os(macOS)
  NSEvent.addLocalMonitorForEvents(
    matching: [.keyUp, .keyDown]) { _ in nil }
#endif


    }

}

